/* ___________________________________________________________
   CORRESP.C
*/

#include <dos.h>
#include <conio.h>

#define F9  	      		0x4300
#define F10 	      		0x4400
#define FL_HAUT       		0x4800
#define FL_BAS        		0x5000
#define SHIFT_F10     		0x5d00

int a[50][50], ligne, colonne;

/* ----------------------------------------------------------- */
void ecran_pres_corresp(void)
{
  gotoxy(10,2); cprintf("ANALYSE FACTORIELLE DES CORRESPONDANCES");
  gotoxy(5,10); cprintf("Fichier  traiter. sans extension.......[F1]");
  gotoxy(5,11); cprintf("Nommer les identificateurs..............[F2]");
  gotoxy(5,12); cprintf("Lancer les calculs......................[F3]");
}

/* ----------------------------------------------------------- */
void corresp(void)
{
  FILE *fic;
  char fichier[15];
  char n$[250];
  unsigned int touch;
  int p[50][30],a[50][30],v[30],r[30][30],pi[50],pj[30];
  int fi[50][4],fj[30][4],po[30],ca[50],cr[50],oj[30],oi[50];

  clrscr();
  ecran_pres_corresp();

  for(;touch!=SHIFT_F10;)
  {
   if ((bioskey(1) == 0))
   {
     touch = bioskey(0);
     switch(touch)
    {

	      case F1:
		      clrscr();
		      gotoxy(5,10); cprintf("Fichier  traiter. sans extension.......[F1]");
		      gotoxy(10;12); scanf("%12s"),fichier);
		      gotoxy(10,14); cprintf("Calcul des correspondances de la matrice : %d",fichier);
		      strcat(fichier,".MAT");
		      fic = fopen(fichier,"a+t");

		      fscanf(fic,"%d,%d\n",&ligne,&colonne);
		      nf=4;
		      for(i=1;i<=ligne;i++)
		      {
		       for(j=1;j<=colonne;j++)
		       {
			fscanf(fic,"%d,",&a[i][j]);
			gotoxy(j*5,pause);
			cprintf("%d,",a[i][j]);
		       }
		       fscanf(fic,"\n");
		      }
		      fclose(fic);
		      clrscr();
		      ecran_pres_corresp();
		      break;

	      case F2:
		      clrscr();
		      gotoxy(10,10); cprintf("Renommer les identificateurs");
		      gotoxy(10,14); cprintf("Entrez les noms des lignes puis ceux des colonnes\n\n");
		      for (compt=1;compt<=ligne+colonne;compt++)
		      {
			cprintf("%d eme nom :");
			scanf("%s",n$); cprintf("\n");
		      }
		      clrscr();
		      ecran_pres_corresp();
		      break;

	      case F3:
		       calcul_pourcent();
                       clrscr();
		       ecran_pres_corresp();
		       break;

	      default:
		       break;
    }
   }
 }
 clrscr();
}

void calcul_pourcent(void)
{
 clrscr();
 gotoxy(5,1); cprintf("Calcul en cours");
 sm=0;
 for (i=1;i<=ligne;i++)
 {
  pi[i]=0;
  for(j=1;j<=colonne;j++)
  {
   pi[i]=pi[i]+p[i][j];
   sm=sm+p[i][j];
  }
 }
 for (j=1;j<=colonne;j++)
 {
  pj[j]=0;
  for(i=1;i<=ligne;i++)
  {
   pj[j]=pj[j]+p[i][j];
   p[i][j]=p[i][j]/sm;
  }
 }
  for(i=1;i<=ligne;i++)
  {
   pi[i]=pi[i]/sm;
  }
  for(j=1;j<=colonne;j++)
  {
   pj[j]=pj[j]/sm;
  }
  for(j=1;j<=colonne;j++)
  {
   for(k=1;k<=j;k++)
   {
    sk=0;
    rk=sqr(pj[j]*pj[k]);
    for(i=1;i<=ligne;i++)
    {
     sk=sk+p[i][j]*p[i][k]/(pi[i]*rk);
    }
    a[j][k]=sk;
    a[k][j]=sk;
   }
  oj[j]=a[j][j]/pj[j]-1;
  }

  calcul_vecteur_propre();

  sv=0;
  for(j=2;j<=colonne;j++)
  {
   v[j]=abs(v[j]);
   sv=sv+v[j];
  }
  for(j=2;j<=colonne;j++)
  {
   po[j]=(v[j]*100)/sv;
  }
  gotoxy(5,24); cprintf("Pourcentage d'information par facteur");
  for(j=1;j<=nf;j++) { cprintf("\n%d",j); }
  for(j=2;j<=nf+1;j++) { cprintf("\n%d",po[j]); }
  for(j=1;j<=jm;j++) 
  { 
   for(jj=1;j<=jm;j++) 
   { 
    r[jj][j]=(r[jj][j]/sqr(pj[jj])*sqr(v[j]);
   } 
  }
  for(j=1;j<=jm;j++) 
  { 
   for(fc=1;fc<=nf;fc++) 
   { 
    fj[j][fc]=r[j][fc+1];
   }
  }


910 LPRINT  "     C.ABSO.F1";" C.RELA.F1";" C.ABSO.F2";" C.RELA.F2";" C.ABSO.F3";" C.RELA.F3.";" C.ABSO.F4";" C.RELA.F4"
920 FOR K=1 TO JM:' **** Contribution j****
930 FOR I=1 TO NF
940 CA(I)=FJ(K,I)*FJ(K,I)*PJ(K)
950 CR(I)=CA(I)/(OJ(K)*PJ(K))
960 CA(I)=(CA(I)/V(I+1))*100
970 NEXT I
980 LPRINT K+IM;:LPRINT USING "#######.##";CA(1);CR(1);CA(2);CR(2);CA(3);CR(3);CA(4);CR(4)
990 NEXT K
995 '
1000 FOR I=1 TO IM
1010 FOR FC=1 TO NF
1020 FI(I,FC)=0
1030 FOR J=1 TO JM
1040 FI(I,FC)=FI(I,FC)+(P(I,J)/PI(I))*FJ(J,FC)/SQR(V(FC+1))
1050 NEXT J
1060 NEXT FC
1070 NEXT I
1075 '
1080 LPRINT: LPRINT"IDENTIFICAT.":LPRINT  "      C.ABSO.F1";" C.RELA.F1";" C.ABSO.F2";" C.RELA.F2";" C.ABSO.F3";" C.RELA.F3";" C.ABSO.F4";" C.RELA.F4"
1090 FOR I=1 TO IM
1100 OI(I)=0
1110 FOR J=1 TO JM
1120 OI(I)=OI(I)+(P(I,J)/PI(I)-PJ(J))^2/PJ(J)
1130 NEXT J
1140 NEXT I
1145 '
1150 FOR K=1 TO IM
1160 FOR I=1 TO NF
1170 CA(I)=FI(K,I)*FI(K,I)*PI(K)
1180 CR(I)=CA(I)/(OI(K)*PI(K))
1190 CA(I)=(CA(I)/V(I+1))*100
1200 NEXT I
1210 LPRINT K;:LPRINT USING"#######.##";CA(1);CR(1);CA(2);CR(2);CA(3);CR(3);CA(4);CR(4)
1220 NEXT K
1225 '
1230 LPRINT
1235 '**** SORTIE DES RESULTATS ****
1240 D$="+#.###"
1250 LPRINT TAB(30)"COORDONNEES DES POINTS"
1260 LPRINT  "    F1","      F2","        F3","          F4"
1270 FOR I=1 TO IM:LPRINT I;:LPRINT USING D$;FI(I,1);:LPRINT"          ";:LPRINT USING D$;FI(I,2);:LPRINT"          ";:LPRINT USING D$;FI(I,3);:LPRINT"          ";:LPRINT USING D$;FI(I,4)
1280 NEXT I:LPRINT:LPRINT
1285 '
1290 LPRINT  "       F1","      F2","        F3","          F4"
1300 FOR J =1 TO JM: LPRINT J+IM;:LPRINT USING D$;FJ(J,1);:LPRINT "           ";:LPRINT USING D$;FJ(J,2);:LPRINT "          ";:LPRINT USING D$;FJ(J,3);:LPRINT "          ";:LPRINT USING D$;FJ(J,4)
1310 NEXT J
1314 LPRINT
1320 GOSUB 2250
1322 END
1323 '


void calcul_vecteur_propre(void)
{

1330 '**** Vecteurs propres et valeurs  propres ***
1340 RA=.0001:N=JM
1350 FOR J=1 TO N
1360 FOR I=1 TO N
1370 R(I,J)=0
1380 IF I=J THEN ELSE 1400
1390 R(I,J)=1
1400 NEXT I
1410 NEXT J
1415 '
1420 AN=0!
1430 FOR I=1 TO N
1440 FOR J=I TO N
1450 IF I=J THEN 1470
1460 AN=AN+A(I,J)*A(I,J)
1470 NEXT J
1480 NEXT I
1485 '
1490 IF AN<=0 THEN 2080
1500 AN=1.414*SQR(AN)
1510 AR=AN*RA/N
1520 IN=0
1530 TH=AN
1540 TH=TH/N
1550 L=1
1560 M=L+1
1570 '
1580 IF ABS(A(L,M))<TH THEN 1980
1590 IN=1
1600 X=.5*(A(L,L)-A(M,M))
1610 Y=-A(L,M)/SQR(A(L,M)*A(L,M)+X*X)
1620 IF X>=0 THEN 1640
1630 Y=-Y
1640 S1=Y/SQR(2!*(1!+(SQR(1!-Y*Y))))
1650 S2=S1*S1
1660 C1=SQR(1!-S2)
1670 C2=C1*C1
1680 SO=S1*C1
1685 '
1690 FOR I=1 TO N
1700 IF I=L THEN 1870
1710 IF I=M THEN 1870
1720 IF I>M THEN 1760
1730 I1=I
1740 I2=M
1750 GOTO 1780
1760 I1=M
1770 I2=I
1780 IF I>=L THEN 1820
1790 I3=I
1800 I4=L
1810 GOTO 1840
1820 I3=L
1830 I4=I
1840 X=A(I3,I4)*C1-A(I1,I2)*S1
1850 A(I1,I2)=A(I3,I4)*S1+A(I1,I2)*C1
1860 A(I3,I4)=X
1870 '
1880 X=R(I,L)*C1-R(I,M)*S1
1890 R(I,M)=R(I,L)*S1+R(I,M)*C1
1900 R(I,L)=X
1910 NEXT I
1915 '
1920 X=2!*A(L,M)*SO
1930 Y=A(L,L)*C2+A(M,M)*S2-X
1940 X=A(L,L)*S2+A(M,M)*C2+X
1950 A(L,M)=(A(L,L)-A(M,M))*SO+A(L,M)*(C2-S2)
1960 A(L,L)=Y
1970 A(M,M)=X
1980 IF M=N THEN 2010
1990 M=M+1
2000 GOTO 1570
2010 IF L=N-1 THEN 2040
2020 L=L+1
2030 GOTO 1560
2040 IF IN<>1 THEN 2070
2050 IN=0
2060 GOTO 1550
2070 IF TH>AR THEN 1540
2075 '
2080 FOR I=1 TO N
2090 FOR J=I TO N
2100 IF A(I,I)>=A(J,J) THEN  2190
2110 X=A(I,I)
2120 A(I,I)=A(J,J)
2130 A(J,J)=X
2140 FOR K=1 TO N
2150 X=R(K,I)
2160 R(K,I)=R(K,J)
2170 R(K,J)=X
2180 NEXT K
2190 NEXT J
2200 NEXT I
2205 '
2210 FOR KV=1 TO N
2220 V(KV)=A(KV,KV)
2230 NEXT KV
2235 '
2240 RETURN
}

2245 '
2247 '**** Ecriture du fichier rsultat ****
2250 OPEN "O",1,FI$+".FAC"
2255 PRINT #1,IM,JM,NF
2260 FOR I=1 TO IM
2270 FOR J=1 TO NF
2280 PRINT #1,FI(I,J);
2290 NEXT J
2300 NEXT I
2305 '
2310 FOR J=1 TO JM
2320 FOR K=1 TO NF
2330  PRINT #1,FJ(J,K);
2340 NEXT K
2350 NEXT J
2355 '
2360 CLOSE

